#ifndef MENU
#define MENU
  #include <avr/pgmspace.h>
#define PS __attribute__((section (".progmem.data")))

#include "x.h"
#include <stdio.h>

#define START 0
#define Z1    1
#define Z2    2
#define Z3    3
#define SubZ1    4
#define Z5    5
#define ERROR  99

#define OK 4
#define PREV 3
#define NEXT 0
#define PREV 3


typedef struct PROGMEM{
  uint8_t state ;
  uint8_t nextState ;
  uint8_t input ;
} TRANSITION_INFO;

typedef struct PROGMEM{
  uint8_t state;
  PGM_P text ;
  char (*p)(char) ;
} STATE_INFO;

uint8_t nextstate(uint8_t s, uint8_t in);
void stateAction(uint8_t state);
STATE_INFO getStateInfo(uint8_t s);

extern PROGMEM const char startText[];
extern PROGMEM const char z1Text[];
extern PROGMEM const char z2Text[];
extern PROGMEM const char z3Text[];
extern PROGMEM const char z4Text[];
extern PROGMEM const char errorText[];



const TRANSITION_INFO transitions [] PS = {
  { START,  Z1      ,NEXT  },
  { START,  Z2      ,PREV  },
  { Z1,     Z2      ,NEXT },
  { Z1,     START   ,PREV  },
  { Z1,     SubZ1   ,OK  },
  { SubZ1,  Z1      ,OK  },
  { SubZ1,  SubZ1   ,NEXT  },
  { SubZ1,  SubZ1   ,PREV  },
  { Z2,     START   ,NEXT  },
  { Z2,     Z1      ,PREV  },
  { ERROR,  ERROR   ,NEXT  }
};
const STATE_INFO states [] PS = {
  { START,startText, NULL},
  { Z1,z1Text, NULL},
  { Z2,z2Text, NULL},
  { SubZ1,NULL, test2},
  { ERROR,errorText, NULL}
};


#endif
